unit goods_flow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IBQuery,DB, IBCustomDataSet,RXDBCtrl,ExtCtrls, DbAGrids,StdCtrls,ToolEdit,
  RXCtrls,xlReport,Buttons;

type
  TGoodsFlowForm = class(TForm)
    qryReport: TIBQuery;
    dsrReport: TDataSource;
    qryReportOBJECT_ID1: TIntegerField;
    qryReportGOODS_KIND_NAME1: TIBStringField;
    qryReportGOODS_MARK_NAME1: TIBStringField;
    qryReportARTICLE1: TIBStringField;
    qryReportA1: TIBBCDField;
    qryReportQ1: TLargeintField;
    qryReportAD1: TIBBCDField;
    qryReportAC1: TIBBCDField;
    qryReportQD1: TLargeintField;
    qryReportQC1: TLargeintField;
    qryReportPRICE_W1: TIBBCDField;
    qryReportPRICE_R1: TIBBCDField;
    qryReportCA1: TIBBCDField;
    qryReportCQ1: TIBBCDField;
    qryReportCOST1: TFloatField;
    qryReportW_RATE1: TFloatField;
    qryReportR_RATE1: TFloatField;
    Panel1: TPanel;
    DbAltGrid1: TDbAltGrid;
    btnQuery: TButton;
    DateEdit1: TDateEdit;
    DateEdit2: TDateEdit;
    cbOrder: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    cbNotZero: TCheckBox;
    clbKind: TRxCheckListBox;
    clbMark: TRxCheckListBox;
    qryGoodsMark: TIBQuery;
    qryGoodsKind: TIBQuery;
    clbStock: TRxCheckListBox;
    qryStock: TIBQuery;
    xlReport1: TxlReport;
    btnReport: TBitBtn;
    procedure qryReportCalcFields(DataSet: TDataSet);
    procedure btnQueryClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure xlReport1Progress(Report: TxlReport; const Position, Max: Integer);
  private
    { Private declarations }
    function GetFilterString(ListBox: TRxCheckListBox;
      Query: TIBQuery; const FieldName: string): string;
    function GetFilterDescription(ListBox: TRxCheckListBox): string;
  public
    { Public declarations }
  end;

var
  GoodsFlowForm: TGoodsFlowForm;

implementation

{$R *.DFM}

const
  SQL_GOODS_FLOW_REPORT =
       'select'#13+
       '  gf.object_id,'#13+
       '  gk.name goods_kind_name,'#13+
       '  gm.name goods_mark_name,'#13+
       '  g.article,'#13+
       '  sum(gf.a) a, sum(gf.q) q, sum(gf.ad) ad, sum(gf.ac) ac,'#13+
       '  sum(gf.qd) qd, sum(gf.qc) qc,'#13+
       '  g.price_w, g.price_r'#13+
       'from'#13+
       '  goods_flow(:DATE1, :DATE2) gf,'#13+
       '  goods g,'#13+
       '  goods_kind gk,'#13+
       '  goods_mark gm'#13+
       'where'#13+
       '  gf.object_id = g.id and'#13+
       '  g.goods_kind = gk.id and'#13+
       '  g.goods_mark = gm.id'#13+
       '%s'+          //    ,   
       'group by'#13+
       '  gf.object_id, gk.name, gm.name, g.article, g.price_w, g.price_r'#13+
       '%s'+          //    
       'order by %s'; //  


procedure TGoodsFlowForm.qryReportCalcFields(DataSet: TDataSet);
begin
  with DataSet do
  begin
    { }
    FieldByName('CA').AsCurrency := FieldByName('A').AsCurrency +
      FieldByName('AD').AsCurrency - FieldByName('AC').AsCurrency;
    FieldByName('CQ').AsCurrency := FieldByName('Q').AsCurrency +
      FieldByName('QD').AsCurrency - FieldByName('QC').AsCurrency;

    {     }
    if FieldByName('CQ').AsCurrency <> 0 then
      FieldByName('COST').AsCurrency :=
        FieldByName('CA').AsCurrency / FieldByName('CQ').AsCurrency;

    {   }
    if FieldByName('COST').AsCurrency <> 0 then
    begin
      FieldByName('W_RATE').AsCurrency :=
        (FieldByName('PRICE_W').AsCurrency /
         FieldByName('COST').AsCurrency - 1) *100;
      FieldByName('R_RATE').AsCurrency :=
        (FieldByName('PRICE_R').AsCurrency /
         FieldByName('COST').AsCurrency - 1)*100;
    end;
  end;
end;

procedure TGoodsFlowForm.btnQueryClick(Sender: TObject);
var
  s_filter, s_having, s_orderby: string;
begin
  ResetCurrentTime;
  StatusBarDisplay(clLime, 0, 0, 0, '', '  ...', '');
  Screen.Cursor := crHourGlass; //    ""
  try
    qryReport.Close;
    {     }
    s_filter := GetFilterString(clbKind, qryGoodsKind, 'g.goods_kind') +
                GetFilterString(clbMark, qryGoodsMark, 'g.goods_mark') +
                GetFilterString(clbStock, qryStock, 'gf.acc_id');
    if cbNotZero.Checked then //   
      s_having := 'having sum(gf.q) <> 0 or sum(gf.qd) <> 0 or sum(gf.qc) <> 0'#13
    else
      s_having := '';

    case cbOrder.ItemIndex of
    1: s_orderby := '3,2,4';
    else
      s_orderby := '2,3,4';
    end;

    qryReport.SQL.Text := Format(SQL_GOODS_FLOW_REPORT,
                          [s_filter, s_having, s_orderby]);

    // ShowMessage(qryReport.SQL.Text); // 

    qryReport.ParamByName('DATE1').AsDateTime := DateEdit1.Date;
    qryReport.ParamByName('DATE2').AsDateTime := DateEdit2.Date;
    qryReport.Open;
  finally
    Screen.Cursor := crDefault; //  
    StatusBarDisplay(clBlack, 0, 0, 0, GetCurrentTimeStr, '', '');
  end;
end;

procedure TGoodsFlowForm.FormCreate(Sender: TObject);
begin
  DateEdit1.Date := EncodeDate(YearOf(Date), MonthOf(Date), 1);
  DateEdit2.Date := Date;
  with qryGoodsKind do
  begin
    Open;
    while not Eof do //   
    begin
      clbKind.Items.Add(Fields[1].AsString);
      Next;
    end;
  end;

  with qryGoodsMark do
  begin
    Open;
    while not Eof do //  
    begin
      clbMark.Items.Add(Fields[1].AsString);
      Next;
    end;
  end;

  with qryStock do
  begin
    Open;
    while not Eof do //  
    begin
      clbStock.Items.Add(Fields[1].AsString);
      Next;
    end;
  end;
end;

{    'and <> in (1,5,6,11,92)' }
function TGoodsFlowForm.GetFilterString(ListBox: TRxCheckListBox;
  Query: TIBQuery; const FieldName: string): string;
begin
  Result := '';
  if ListBox.Checked[0] then
    exit;
  with Query do //  
  begin
    First;
    while not Eof do
    begin
      if ListBox.Checked[RecNo] then //  
      begin                          //   
        if Result <> '' then Result := Result + ','; // 
        Result := Result + Fields[0].AsString; //  
      end;
      Next;
    end;
  end;
  if Result <> '' then //   
    Result := Format('  and %s in (%s)'#13, [FieldName, Result]);
end;

procedure TGoodsFlowForm.btnReportClick(Sender: TObject);
begin
  xlReport1.ParamByName('STOCKS').Value := ': ' + GetFilterDescription(clbStock);
  xlReport1.ParamByName('KINDS').Value := ' : ' + GetFilterDescription(clbKind);
  xlReport1.ParamByName('MARKS').Value := ': ' + GetFilterDescription(clbMark);
  xlReport1.ParamByName('DATES').Value :=
    ': ' + DateToStr(DateEdit1.Date) + '..' + DateToStr(DateEdit2.Date);
  xlReport1.Report;
end;

procedure TGoodsFlowForm.xlReport1Progress(Report: TxlReport; const Position, Max: Integer);
begin
  if Position = 0 then
    StatusBarDisplay(clBlack, Position, 0, Max, '', '', '')
  else
    StatusBarDisplay(clLime, Position, 0, Max, '', '  Excel...', '');
end;

{    }
function TGoodsFlowForm.GetFilterDescription(ListBox: TRxCheckListBox): string;
var
  i: integer;
begin
  Result := '';
  with ListBox do // 
  for i := 0 to Items.Count - 1 do
  if Checked[i] then //      
  begin
    if Result <> '' then Result := Result + ', '; // 
    Result := Result + ListBox.Items[i]; //  
  end;
end;

end.