unit monte_carlo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IBQuery, IBDatabase, ComCtrls, StdCtrls,IBCustomDataSet;

type
  TForm1 = class(TForm)
    qryContragent: TIBQuery;
    traCurrent: TIBTransaction;
    qryGoods: TIBQuery;
    ProgressBar1: TProgressBar;
    qryStock_In: TIBDataSet;
    qrySale: TIBDataSet;
    btnGenerate: TButton;
    btnDelete: TButton;
    qry: TIBQuery;
    qryStock_In_Item: TIBDataSet;
    qrySale_Item: TIBDataSet;
    ProgressBar2: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnGenerateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  traCurrent.StartTransaction;
  qryContragent.Open;
  qryContragent.FetchAll;
  qryGoods.Open;
  qryGoods.FetchAll;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    with qry do
    begin
      SQL.Text := 'DELETE FROM STOCK_IN';
      ExecSQL;
      SQL.Text := 'DELETE FROM SALE';
      ExecSQL;
      SQL.Text := 'update template set is_changed = 1'#13+
                  'where template_id in (102, 103)';
      ExecSQL;
    end;
    qryStock_in.Close;
    qrySale.Close;

    traCurrent.CommitRetaining;    // 
    UpdateTurnovers(True);   // 
    btnGenerate.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
  ShowMessage('  ');
end;

procedure TForm1.btnGenerateClick(Sender: TObject);
const
  stock_in_count = 100;
  stock_in_item_count = 1000;
  sale_count = 350;
var
  i, contragent,
  goods, quantity, price_USD,
  sales_from, sale_quantity: integer;
begin
  btnGenerate.Enabled := False;
  qryStock_in.Open;
  qrySale.Open;
  ProgressBar1.Max := stock_in_count + sale_count;
  {    ( )}
  for i := 1 to stock_in_count do
  begin
    {  }
    with qryContragent do
    begin
      RecNo := random(RecordCount) + 1;
      contragent := FieldByName('ID').AsInteger;
    end;
    { "  "}
    with qryStock_In do
    begin
      Insert; //   
      FieldByName('DIR_ID').AsInteger := 1001; // ""
      FieldByName('STOCK_ACC').AsInteger := 1007; // " "
      {    3 ,    2003 }
      FieldByName('ENTRY_DATE').AsDateTime := EncodeDate(2003,1,1) + 3*i;
      FieldByName('DOC_KIND').AsInteger := 0; //  
      FieldByName('ACC_ID').AsInteger := 1012; // ""
      FieldByName('CONTRAGENT').AsInteger := contragent;
      {1 +    ID   3    }
      FieldByName('LAYER_ID').AsInteger := 1 + contragent mod 3;
      FieldByName('CALC_MODE').AsInteger := 1; //   c 
      FieldByName('HAS_ENTRY').AsInteger := 1; //   
      FieldByName('DOC_DATE').AsDateTime := FieldByName('ENTRY_DATE').AsDateTime;
      FieldByName('VAT_RATE').AsInteger := 20; // 
      FieldByName('EXCH_RATE_S').AsCurrency := 30+random(100)/100; // 
      {      }
      case FieldByName('LAYER_ID').AsInteger of
      1: FieldByName('EXCH_RATE_L').AsCurrency := 1; // 
      2: FieldByName('EXCH_RATE_L').AsCurrency :=
          FieldByName('EXCH_RATE_S').AsCurrency; // 
      3: FieldByName('EXCH_RATE_L').AsCurrency := 32+random(100)/100; // 
      end;
      {  ""  0}
      FieldByName('TOTAL_L').AsCurrency := 0;
      FieldByName('TOTAL_S').AsCurrency := 0;
      FieldByName('TOTAL_R').AsCurrency := 0;
      {   }
      FieldByName('DOC_NO').AsString := IntToStr(i);
      Post; //  
    end;
    ProgressBar1.Position := i; // 
  end;

  {  ( )}
  for i := 1 to sale_count do
  begin
    {  }
    with qryContragent do
    begin
      RecNo := random(RecordCount) + 1;
      contragent := FieldByName('ID').AsInteger;
    end;
    { ""}
    with qrySale do
    begin
      Insert; //   
      FieldByName('DIR_ID').AsInteger := 1002; // ""
      FieldByName('STOCK_ACC').AsInteger := 1007; // " "
      {   ,   1  2003 }
      FieldByName('ENTRY_DATE').AsDateTime := EncodeDate(2003,1,1) + i;
      FieldByName('CONTRAGENT').AsInteger := contragent;
      {1 +    ID   3    }
      FieldByName('LAYER_ID').AsInteger := 1 + contragent mod 3;
      FieldByName('CALC_MODE').AsInteger := 1; //   c 
      FieldByName('HAS_ENTRY').AsInteger := 1; //   
      FieldByName('DOC_DATE').AsDateTime := FieldByName('ENTRY_DATE').AsDateTime;
      FieldByName('VAT_RATE').AsInteger := 20; // 
      FieldByName('EXCH_RATE_S').AsCurrency := 30+random(100)/100; // 
      {      }
      case FieldByName('LAYER_ID').AsInteger of
      1: FieldByName('EXCH_RATE_L').AsCurrency := 1; // 
      2: FieldByName('EXCH_RATE_L').AsCurrency :=
          FieldByName('EXCH_RATE_S').AsCurrency; // 
      3: FieldByName('EXCH_RATE_L').AsCurrency := 32+random(100)/100; // 
      end;
      {  ""  0}
      FieldByName('TOTAL_L').AsCurrency := 0;
      FieldByName('TOTAL_S').AsCurrency := 0;
      FieldByName('TOTAL_R').AsCurrency := 0;
      {   }
      FieldByName('DOC_NO').AsString := IntToStr(i);
      FieldByName('PRICE_TYPE').AsInteger := 0;
      FieldByName('PRICE_DISCOUNT').AsCurrency := 0;
      Post; //  
    end;
    ProgressBar1.Position := stock_in_count + i; // 
  end;
//  ShowMessage('   ');

  {     }
  ProgressBar2.Max := stock_in_item_count;
  for i := 1 to stock_in_item_count do
  begin
    {  }
    with qryGoods do
    begin
      RecNo := random(RecordCount) + 1;
      goods := FieldByName('ID').AsInteger;
    end;
    {    }
    with qryStock_In do
      RecNo := random(RecordCount) + 1;
    { }
    quantity := random(5) + 1; //  ()
    price_USD := 100 + random(200); //  USD
    {     }
    with qryStock_In_Item do
    begin
      Open;
      Insert;
      FieldByName('ID').AsInteger := qryStock_In.FieldByName('ID').AsInteger;
      FieldByName('GOODS').AsInteger := goods;
      FieldByName('QUANTITY').AsInteger := quantity;
      {    
       -    }
      FieldByName('PRICE_L').AsCurrency := round(price_USD *
        qryStock_In.FieldByName('EXCH_RATE_S').AsCurrency /
        qryStock_In.FieldByName('EXCH_RATE_L').AsCurrency * 100)/100;
      {      }
      FieldByName('PRICE_L_WO_VAT').AsCurrency :=
        FieldByName('PRICE_L').AsCurrency/
        (1 + qryStock_In.FieldByName('VAT_RATE').AsCurrency/100);
      {       }
      FieldByName('PRICE_R').AsCurrency := round(price_USD *
        qryStock_In.FieldByName('EXCH_RATE_S').AsCurrency * 100)/100;
      {     }
      FieldByName('PRICE_R_WO_VAT').AsCurrency :=
        FieldByName('PRICE_R').AsCurrency/
        (1 + qryStock_In.FieldByName('VAT_RATE').AsCurrency/100);
      { }
      FieldByName('AMOUNT_L').AsCurrency :=
        FieldByName('PRICE_L').AsCurrency * quantity;
      FieldByName('AMOUNT_S').AsCurrency :=  price_USD * quantity;
      FieldByName('AMOUNT_R').AsCurrency :=
        FieldByName('PRICE_R').AsCurrency * quantity;

      {  ,      }
      qrySale.Locate('ENTRY_DATE',
          qryStock_In.FieldByName('ENTRY_DATE').AsDateTime,
          MkSet());
      sales_from := qrySale.RecNo; //   
      Post;
      Close;
    end;

    {  10%}
    price_USD := price_USD * 1.1;
    {   ,      }
    repeat
      sale_quantity := random(quantity) + 1; // 
      {  }
      with qrySale do
        RecNo := sales_from + random(RecordCount - sales_from) + 1;
      {   }
      with qrySale_Item do
      begin
        Open;
        Insert;
        FieldByName('ID').AsInteger := qrySale.FieldByName('ID').AsInteger;
        FieldByName('GOODS').AsInteger := goods;
        FieldByName('QUANTITY').AsInteger := sale_quantity;
        {    
         -    }
        FieldByName('PRICE_L').AsCurrency := round(price_USD *
          qrySale.FieldByName('EXCH_RATE_S').AsCurrency /
          qrySale.FieldByName('EXCH_RATE_L').AsCurrency * 100)/100;
        {      }
        FieldByName('PRICE_L_WO_VAT').AsCurrency :=
          FieldByName('PRICE_L').AsCurrency/
          (1 + qrySale.FieldByName('VAT_RATE').AsCurrency/100);
        {       }
        FieldByName('PRICE_R').AsCurrency := round(price_USD *
          qrySale.FieldByName('EXCH_RATE_S').AsCurrency * 100)/100;
        {     }
        FieldByName('PRICE_R_WO_VAT').AsCurrency :=
          FieldByName('PRICE_R').AsCurrency/
          (1 + qrySale.FieldByName('VAT_RATE').AsCurrency/100);
        { }
        FieldByName('AMOUNT_L').AsCurrency :=
          FieldByName('PRICE_L').AsCurrency * sale_quantity;
        FieldByName('AMOUNT_S').AsCurrency :=  price_USD * sale_quantity;
        FieldByName('AMOUNT_R').AsCurrency :=
          FieldByName('PRICE_R').AsCurrency * sale_quantity;
        {   0}
        FieldByName('COST_S').AsCurrency := 0;
        Post;
        Close;
      end;
      quantity := quantity - sale_quantity; //   
    until quantity <= 0;
    ProgressBar2.Position := i; // 
  end;

  {    }
  with qry do
  begin
    SQL.Text := 'EXECUTE PROCEDURE update_stock_in_totals';
    ExecSQL;
    SQL.Text := 'EXECUTE PROCEDURE update_sale_totals';
    ExecSQL;
    {  ,     }
    SQL.Text := 'DELETE FROM SALE WHERE TOTAL_S = 0';
    ExecSQL;
  end;

  traCurrent.CommitRetaining;    // 
  UpdateTurnovers(True);   // 
//  ShowMessage('   ');

  {    }
  with qry do
  begin
    SQL.Text := 'EXECUTE PROCEDURE sale_item_update_cost(1007)';
    ExecSQL;
  end;

  traCurrent.CommitRetaining;    // 
  UpdateTurnovers(True);   // 

  ProgressBar1.Position := 0;
  ProgressBar2.Position := 0;
  ShowMessage('  ');
end;

end.